#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

##----------------------------------------------------------------------------------------------
## Coban - Module chauffage
## Copyright 2008-2009  Stphan GURIN
## contact : setthe@tuxfamily.org
##
## Ce logiciel est un programme informatique destin aux lectriciens et 
## permettant de calculer rapidement la section d'un cble, de raliser des
## conversions d'units lectriques, etc.... 
##
## Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
## respectant les principes de diffusion des logiciels libres. Vous pouvez
## utiliser, modifier et/ou redistribuer ce programme sous les conditions
## de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
## sur le site "http://www.cecill.info".
##
## En contrepartie de l'accessibilit au code source et des droits de copie,
## de modification et de redistribution accords par cette licence, il n'est
## offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
## seule une responsabilit restreinte pse sur l'auteur du programme,  le
## titulaire des droits patrimoniaux et les concdants successifs.
##
## A cet gard  l'attention de l'utilisateur est attire sur les risques
## associs au chargement,   l'utilisation,   la modification et/ou au
## dveloppement et  la reproduction du logiciel par l'utilisateur tant 
## donn sa spcificit de logiciel libre, qui peut le rendre complexe  
## manipuler et qui le rserve donc  des dveloppeurs et des professionnels
## avertis possdant  des  connaissances  informatiques approfondies.  Les
## utilisateurs sont donc invits  charger  et  tester  l'adquation  du
## logiciel  leurs besoins dans des conditions permettant d'assurer la
## scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
##  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
##
## Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
## pris connaissance de la licence CeCILL, et que vous en avez accept les
## termes.
##
##----------------------------------------------------------------------------------------------

import wx
import pickle, os
from modcoban import icone, ValidDigitPoint, testFloat, testFich, fichierConf

############################################################################
##                                                                        ##
##             Module de calculs de puissance calorifique                 ##
##                                                                        ##
##                                                                        ##
############################################################################

#---------------------------------------------------------------------------

version = "0.1.9"

#----------- fichier de sauvegarde des prfrences -----------

f = open(fichierConf, 'r')
path = pickle.load(f)
f.close()

fichierPref = os.path.join(os.path.expanduser(path), "prefcalo.cob")

# valeurs par dfaut du fichier des sauvegarde des prfrences
valDef = [33,85,80]

#----------- messages d'aide -----------------------

aidePlancher = (u'Surface de la pice en m2.\n'
                u'* Pour les salles de bains, penser  enlever la\n'
                u'  surface occupe par la baignoire et/ou la douche\n'
                u'* Pour les cuisines, penser  enlever la\n'
                u'  surface occupe par les lments de cuisine')
aideAutre = u'Surface de la pice en m2.'


#---------------------------------------------------------------------------

def testPref(f) :
    test = testFich(f)
    if test == 0 :
        fich = open(f,'w')
        pickle.dump(valDef, fich)
        fich.close()


def lireDef(f):
    """ retourne la liste des valeurs du fichier des prfrences """
    testPref(f)
    fich = open(f, 'r')
    lstPdef = pickle.load(fich)
    fich.close()
    return lstPdef


#---------------------------------------------------------------------------


class Pref(wx.Frame):
    """Fentre des prfrences"""
       
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE,
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.parent = parent
        
        #----------- Cration du panel ------------------
        panel = wx.Panel(self, -1)
        
        #------- cration du sizer principal -----------------
        gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        #--------- Lecture des valeurs par dfaut ------------
        lst = lireDef(fichierPref)
        PpannDef = lst[0]
        PplanDef = lst[1]
        Paccudef = lst[2]
        
        #--------- Cration des widgets --------------------
        labelPpann = wx.StaticText(panel, -1, 'Chauffage par panneaux rayonnants :\nPuissance en Watts/m3 :')
        self.Ppann = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.Ppann.SetRange(1,150)
        self.Ppann.SetValue(PpannDef)
        
        labelPplan = wx.StaticText(panel, -1, u'Chauffage par cble chauffant :\nPuissance en Watts/m2 :')
        self.Pplan = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.Pplan.SetRange(1,150)
        self.Pplan.SetValue(PplanDef)
        
        labelPaccu = wx.StaticText(panel, -1, 'Chauffage par accumulateurs :\nPuissance en Watts/m3 :')
        self.Paccu = wx.SpinCtrl(panel, -1, "", size=(50,-1))
        self.Paccu.SetRange(1,400)
        self.Paccu.SetValue(Paccudef)
        
        btnValid = wx.Button(panel, -1, "Valider")
        btnValid.SetDefault()
        self.Bind(wx.EVT_BUTTON, self.onValid, btnValid)
        
        btnReset = wx.Button(panel, -1, u"Valeurs par dfaut")
        self.Bind(wx.EVT_BUTTON, self.onReset, btnReset)
        
        #-------------- Ajout des wigets au sizer --------------------
        
        gbs.Add(labelPpann, (0,0))
        gbs.Add(labelPplan, (1,0))
        gbs.Add(labelPaccu, (2,0))
        gbs.Add(self.Ppann, (0,1))
        gbs.Add(self.Pplan, (1,1))
        gbs.Add(self.Paccu, (2,1))
        gbs.Add(btnValid, (3,2))
        gbs.Add(btnReset, (3,0))
        
        panel.SetSizerAndFit(gbs)
        self.SetClientSize(panel.GetSize())
    
    def onReset(self,evt):
        self.Ppann.SetValue(valDef[0])
        self.Pplan.SetValue(valDef[1])
        self.Paccu.SetValue(valDef[2])


    def onValid(self, event):
        testPref(fichierPref)
        f= open(fichierPref, "w")
        pan = self.Ppann.GetValue()
        plan = self.Pplan.GetValue()
        accu = self.Paccu.GetValue()
        pickle.dump([pan, plan, accu], f)
        f.close()
        
            
        #--------- Lecture des coefs par dfaut ------------
        lst = lireDef(fichierPref)
        PpannDef = lst[0]
        PplanDef = lst[1]
        Paccudef = lst[2]
        
        # modification dans la fenetre chauffage de l'affichage de la puissance de calcul et du rsultat
        if self.parent.typeChauf.GetStringSelection() == self.parent.listeTypeChauf[0]: # si panneau
            self.parent.labelTypeCalc.SetLabel("%s W/m3"%PpannDef)
        elif self.parent.typeChauf.GetStringSelection() == self.parent.listeTypeChauf[2]: # si accu
            self.parent.labelTypeCalc.SetLabel("%s W/m3"%Paccudef)
        else : # si plancher
            self.parent.labelTypeCalc.SetLabel("%s W/m2"%PplanDef)
        
        self.parent.pCalc.SetLabel('... W')
        self.parent.pSup.SetLabel('')
        
        # enlve la proprite "modale" de la fentre
        self.MakeModal(False)
        self.Close(True)
        
        

  
class Chauffage(wx.Frame):
    """Module de calculs de puissance calorifique"""
       
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, title = 'Chauffage version %s'%version, 
                          style=wx.DEFAULT_FRAME_STYLE 
                          ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
        self.parent = parent
        
        #----------- Cration du panel ------------------
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        
        #------- cration du sizer principal -----------------
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        #------------- Cration de statusbar -----------------
        
        self.CreateStatusBar()
        self.SetStatusText("Calculs de puissances calorifiques")
        
        #-------------- import des images ----------------------
        
        from modcoban import bmp_pref, bmp_pref_16, bmp_quit, bmp_quit_16
        
        img_pref = wx.Bitmap(bmp_pref, wx.BITMAP_TYPE_PNG)
        img_quit = wx.Bitmap(bmp_quit, wx.BITMAP_TYPE_PNG)
        img_pref_16 = wx.Bitmap(bmp_pref_16, wx.BITMAP_TYPE_PNG)
        img_quit_16 = wx.Bitmap(bmp_quit_16, wx.BITMAP_TYPE_PNG)
        
        #-------------- CRATION DES MENUS ---------------------
        
        barreMenu = wx.MenuBar()
        
        self.menu1 = wx.Menu()
        self.menu1pref = wx.MenuItem(self.menu1, wx.ID_PREFERENCES, 
                                     u"Rglages", u"Rglages des paramtres de calcul")
        self.menu1pref.SetBitmap(img_pref_16)
        self.menu1.AppendItem(self.menu1pref)
        self.Bind(wx.EVT_MENU, self.onPref, self.menu1pref)
        
        self.menu1.AppendSeparator()

        self.menu1Quit = wx.MenuItem(self.menu1, wx.ID_EXIT,
                                     u"Quitter", u"Quitter ce module...")
        self.menu1Quit.SetBitmap(img_quit_16)
        self.menu1.AppendItem(self.menu1Quit)
        self.Bind(wx.EVT_MENU, self.onQuitter, self.menu1Quit)
        
        barreMenu.Append(self.menu1, u"&Prfrences") 
        self.SetMenuBar(barreMenu)
        
        #---- Cration de la barre d'outils (toolbar) ---------------------------------------------------
        
        self.tbar = wx.ToolBar(self, -1, style= wx.TB_HORIZONTAL)
        # Hack pour windows :
        # ajustement de la taille des boutons aux images (24x24 px):
        self.tbar.SetToolBitmapSize((24,24))
        
        self.tbar.AddSimpleTool(wx.ID_PREFERENCES, 
                                img_pref,
                                shortHelpString = u"Rglages",
                                longHelpString = u"Rglage des paramtres de calcul")
        self.tbar.AddSeparator()
        self.tbar.AddSimpleTool(wx.ID_EXIT, 
                           img_quit,
                           shortHelpString = "Quitter",
                           longHelpString = "Quitter ce module")
        self.tbar.Realize()
        self.SetToolBar(self.tbar)
        
        
        
        #--------- Lecture des coefs par dfaut ------------
        lst = lireDef(fichierPref)
        PplanDef = lst[1]
        
        #------------- cration des widgets -----------------
        
        # titres
        fontTitre = wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD)
        lblProjet = wx.StaticText(panel, -1, u"Donnes du projet")
        lblProjet.SetFont(fontTitre)
        lblResult = wx.StaticText(panel, -1, u"Rsultats")
        lblResult.SetFont(fontTitre)
        
        # Choix de slection du type de chauffage
        self.listeTypeChauf = ['Radiateurs',u'Cble chauffant','Accumulateurs']
        labelType = wx.StaticText(panel, -1, u"Mode de chauffage :")
        self.typeChauf = wx.Choice(panel, -1, (-1, -1), choices = self.listeTypeChauf)
        self.typeChauf.SetStringSelection(self.listeTypeChauf[1])
        
        # Choix de la surface
        labelSurface = wx.StaticText(panel, -1, 'Surface (en m2) :')
        self.surface = wx.TextCtrl(panel, -1, "", validator=ValidDigitPoint())
        self.surface.SetToolTipString(aidePlancher)
        self.bain = wx.CheckBox(panel, -1, "Salle de bain ?")
        self.bain.SetToolTipString(u'Cocher cette case si la pice est une salle de bain')
        
        # Choix hauteur sous plafond
        labelHsp= wx.StaticText(panel, -1, 'H.S.P. (en m) :')
        self.hsp = wx.TextCtrl(panel, -1, "2.5", validator = ValidDigitPoint())
        self.hsp.SetToolTipString(u'Hauteur sous plafond en mtres')
        
        # sparation
        sep = wx.BoxSizer(wx.VERTICAL)
        sep.Add(wx.StaticLine(panel), 0, wx.EXPAND|wx.ALL, 5)
        
        # Fentre "mode de calcul"
        labelModeCalc = wx.StaticText(panel, -1, u"Mode de calcul : ")
        labelModeCalc.SetFont(wx.Font(8, wx.SWISS, wx.NORMAL,wx.NORMAL))
        self.labelTypeCalc = wx.StaticText(panel, -1, "%s W/m2"%PplanDef)
        self.labelTypeCalc.SetFont(wx.Font(8, wx.SWISS, wx.NORMAL,wx.NORMAL))
        
        # Fentre "Puissance calcule"
        labelPCalc = wx.StaticText(panel, -1, u"Puissance calcule :", style=wx.ALIGN_RIGHT)
        self.pCalc = wx.StaticText(panel, -1, '... W')
        self.pCalc.SetForegroundColour('blue')
        self.pCalc.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.labelPsup = wx.StaticText(panel, -1, u'Puissance\ncomplmentaire :')
        self.pSup = wx.StaticText(panel, -1, u'')
        
        # bouton Calcul
        self.btnCalc = wx.Button(panel, -1, "calculer")
        self.btnCalc.SetDefault()
        self.btnCalc.SetBackgroundColour('yellow')
        if self.parent.licence_ok == 0:
            self.btnCalc.Enable(False)
        
        #-------------- Binds -------------------
        self.Bind(wx.EVT_BUTTON, self.onCalcul, self.btnCalc)
        self.Bind(wx.EVT_CLOSE, self.onQuitter)
        self.typeChauf.Bind(wx.EVT_CHOICE, self.onTypeChauf, self.typeChauf)
        
        #-------------- Ajout des wigets au sizer --------------------
        self.gbs.Add(lblProjet, (0,0), (1,2), wx.EXPAND)
        self.gbs.Add(labelType, (1,0))
        self.gbs.Add(self.typeChauf, (1,1),(1,2),wx.EXPAND)
        self.gbs.Add(labelSurface, (2,0))
        self.gbs.Add(self.surface, (2,1))
        self.gbs.Add(self.bain, (2,2))
        self.gbs.Add(labelHsp, (3,0))
        self.gbs.Add(self.hsp, (3,1))
        self.gbs.Add(self.btnCalc, (4,2))
        self.gbs.Add(sep, (5,0), (1,3),wx.EXPAND)
        self.gbs.Add(lblResult, (6,0))
        self.gbs.Add(labelModeCalc, (7,0))
        self.gbs.Add(self.labelTypeCalc, (7,1))
        self.gbs.Add(labelPCalc, (8,0))
        self.gbs.Add(self.pCalc, (8,1))
        self.gbs.Add(self.labelPsup, (9,0))
        self.gbs.Add(self.pSup, (9,1))
                
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        self.labelPsup.SetLabel(u'')
        
        
        
    def onTypeChauf(self, evt):
        """Modifie les paramtres en fonction du type de chauffage"""
        
        #--------- Lecture des coefs par dfaut ------------
        lst = lireDef(fichierPref)
        PpannDef = lst[0]
        PplanDef = lst[1]
        Paccudef = lst[2]
        
        self.pCalc.SetLabel('... W')
        self.labelPsup.SetLabel('')
        self.pSup.SetLabel('')
        
        if self.typeChauf.GetStringSelection() != self.listeTypeChauf[1]: # si panneau ou accu
            self.bain.Enable(False)
            self.bain.Set3StateValue(wx.CHK_UNCHECKED)
            self.surface.SetToolTipString(aideAutre)
            if self.typeChauf.GetStringSelection() == self.listeTypeChauf[0]: # si panneau
                self.labelTypeCalc.SetLabel("%s W/m3"%PpannDef)
            else : # si accu
                self.labelTypeCalc.SetLabel("%s W/m3"%Paccudef)
            
        else : # si plancher
            self.bain.Enable(True)
            self.surface.SetToolTipString(aidePlancher)
            self.labelTypeCalc.SetLabel("%s W/m2"%PplanDef)
        
        

    def onPref(self, evt):
        testPref(fichierPref)
        dlg = Pref(self, -1, u"Rglages", size=(350, 200),
                   style=wx.DEFAULT_FRAME_STYLE 
                   ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX | wx.MINIMIZE_BOX| wx.CLOSE_BOX))
        icone(dlg)
        dlg.Show(True) 
        # la fentre des prfrence devient modale
        dlg.MakeModal(True)
        
        
        
    def onCalcul (self, evt):
        """Calcul de la puissance calorifique"""
        
        #--------- Rcupration des valeurs saisies -----------
        s = testFloat(self.surface)
        h = testFloat(self.hsp)
        vol = s*h
        chauf = self.typeChauf.GetStringSelection()
        bain = self.bain.Get3StateValue()
        
        #--------- Lecture des coefs par dfaut ------------
        lst = lireDef(fichierPref)
        PpannDef = lst[0]
        PplanDef = lst[1]
        Paccudef = lst[2]
        
        if chauf == self.listeTypeChauf[0]: # panneaux
            p = round(vol*PpannDef)
        if chauf == self.listeTypeChauf[1]: # plancher
            if bain == 0:
                s = s*0.85
                p = int(s*PplanDef)
            else :
                p = int(s*PplanDef)
            
            # si hsp > 2,5m, calcul de P supp  installer
            if h > 2.5 :
                p2 = int(vol*PpannDef)-p
                self.labelPsup.SetLabel(u'Puissance\ncomplmentaire :')
                self.pSup.SetLabel(u'%s W'%p2)
                self.pSup.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
            else :
                self.labelPsup.SetLabel('')
                self.pSup.SetLabel('')
                
        if chauf == self.listeTypeChauf[2]: # accus
            p = int(vol*Paccudef)
            
        self.pCalc.SetLabel('%s W'%p)
            
   
    
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.parent.btnChauff.Enable(True)
        self.parent.menuModuleChauffage.Enable(True)
        self.Destroy()
    