#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

##----------------------------------------------------------------------------------------------
## Coban - Module Chauffage tertiaire
## Copyright 2008-2009  Stphan GURIN
## contact : setthe@tuxfamily.org
##
## Ce logiciel est un programme informatique destin aux lectriciens et 
## permettant de calculer rapidement la section d'un cble, de raliser des
## conversions d'units lectriques, etc.... 
##
## Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
## respectant les principes de diffusion des logiciels libres. Vous pouvez
## utiliser, modifier et/ou redistribuer ce programme sous les conditions
## de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
## sur le site "http://www.cecill.info".
##
## En contrepartie de l'accessibilit au code source et des droits de copie,
## de modification et de redistribution accords par cette licence, il n'est
## offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
## seule une responsabilit restreinte pse sur l'auteur du programme,  le
## titulaire des droits patrimoniaux et les concdants successifs.
##
## A cet gard  l'attention de l'utilisateur est attire sur les risques
## associs au chargement,   l'utilisation,   la modification et/ou au
## dveloppement et  la reproduction du logiciel par l'utilisateur tant 
## donn sa spcificit de logiciel libre, qui peut le rendre complexe  
## manipuler et qui le rserve donc  des dveloppeurs et des professionnels
## avertis possdant  des  connaissances  informatiques approfondies.  Les
## utilisateurs sont donc invits  charger  et  tester  l'adquation  du
## logiciel  leurs besoins dans des conditions permettant d'assurer la
## scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
##  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
##
## Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
## pris connaissance de la licence CeCILL, et que vous en avez accept les
## termes.
##
##----------------------------------------------------------------------------------------------

import wx
import os


############################################################################
##                                                                        ##
##                       Module Chauffage tertiaire                       ##
##                                                                        ##
##                                                                        ##
############################################################################

version = "0.1"

  
class ChauffTertiaire(wx.Frame):
    """Module de calcul de chauffage tertiaire et industriel"""
       
    def __init__(self, parent):
        
        wx.Frame.__init__(self, parent, -1, title = "Chauffage Tertiaire %s"%version, size=(500,500), 
                          style=wx.DEFAULT_FRAME_STYLE 
                          ^(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))# | wx.CLOSE_BOX))
        self.parent = parent
        
        ############## Cration du panel #########################
        
        panel =  wx.Panel(self, -1, style = wx.TAB_TRAVERSAL
                     | wx.CLIP_CHILDREN
                     | wx.FULL_REPAINT_ON_RESIZE
                     )
        
        #------------- cration du sizer principal -----------------
        
        self.gbs = wx.GridBagSizer(hgap=5, vgap=5)
        
        #------------- Cration de statusbar ---------------------
        
        self.CreateStatusBar()
        self.SetStatusText("Consultez l'aide pour plus d'informations")
        
        #--------------- cration des widgets --------------------

        # insertion de l'image
        def opj(path):
            """Convert paths to the platform-specific separator"""
            st = apply(os.path.join, tuple(path.split('/')))
            # HACK: on Linux, a leading / gets lost...
            if path.startswith('/'):
                st = '/' + st
            return st
        pos = 100
        img = wx.Image(opj('images/france.png'), wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        pos = pos + img.GetHeight() + 10
        self.carte = wx.StaticBitmap(panel, -1, img, (10, pos), (img.GetWidth(), img.GetHeight()))
        
        # choix de la zone
        btnSize = (25,25)
        lblChoixZone = wx.StaticText(panel, -1, u"Emplacement du local:")
        self.btnRouge = wx.Button(panel, 100, "", size=btnSize)
        self.btnRouge.SetBackgroundColour('red')
        self.btnVert = wx.Button(panel, 102, "", size=btnSize)
        self.btnVert.SetBackgroundColour('green')
        self.btnBleu = wx.Button(panel, 101, "", size=btnSize)
        self.btnBleu.SetBackgroundColour('blue')        
        self.btnJaune = wx.Button(panel, 103, "", size=btnSize)
        self.btnJaune.SetBackgroundColour('yellow')
        
        # volume
        lblVolume = wx.StaticText(panel, -1, u"Volume du local en m3 :")
        self.volume = wx.SpinCtrl(panel, -1, "")
        self.volume.SetRange(10,500)
        self.volume.SetValue(100)
        
        taille1 = self.volume.GetSizeTuple()
        # HSP :
        lblHsp = wx.StaticText(panel, -1, u"Hauteur sous plafond\n(en m) :")
        choixHsp = [u'< 5m', u'5m', u'6m', u'8m', u'10m']
        self.hsp = wx.Choice(panel, -1, choices=choixHsp, size=taille1)
        self.hsp.SetSelection(0)
        
        # NB Personnes :
        lblNbPersonnes = wx.StaticText(panel,-1, u'Nombre de personnes\noccupant le local :')
        self.personnes = wx.SpinCtrl(panel, -1, "", size=taille1)
        self.personnes.SetRange(0,99)
        self.personnes.SetValue(10)
        
        # type de local
        lblLocal = wx.StaticText(panel, -1, u"Type de local :")
        loc = [u"Bureaux", u"Ateliers, entrepts, magasins..."]
        self.local = wx.Choice(panel, -1, choices=loc, size=taille1)
        self.local.SetSelection(1)
        
        taille2 = taille1
        # environnement :
        lblEnvironnement = wx.StaticText(panel, -1, u"Environnement du local :")
        choixEnv = [u"Murs extrieurs bien exposs : Murs intrieurs entours de locaux chauffs.", 
                    u'1 mur extrieur mal expos : Murs intrieurs entours de locaux chauffs.', 
                    u'2 ou 3 murs extrieurs mal exposs : Murs intrieurs entours de locaux peu ou pas chauffs.']
        self.environnement = wx.Choice(panel, -1, choices=choixEnv, size = taille2)
        self.environnement.SetSelection(0)
        
        # construction :
        lblConstruction = wx.StaticText(panel, -1, u'Construction du local :')
        choixConstr = [u'Murs pais (25cm).',
                       u'Construction lgre : ossature bton, grands vitrages...',
                       u'Construction trs lgre : portes frquemment ouvertes']
        self.construction = wx.Choice(panel, -1, choices=choixConstr, size = taille2)
        self.construction.SetSelection(1)
        
        # altitude :
        lblAltitude = wx.StaticText(panel, -1, u"Altitude du local :")
        choixAltitude = [u'< 200m', u'200  500m', u'500  1000m', u'1000  1500m', u'1500  2000m']
        self.altitude = wx.Choice(panel, -1, choices=choixAltitude)
        self.altitude.SetSelection(0)
        
        # bouton calcul
        self.btnCalcul = wx.Button(panel, -1, "Calculer")
        self.btnCalcul.Enable(False)
        self.btnCalcul.SetDefault()
        if self.parent.licence_ok == 0:
            self.btnCalcul.Enable(False)
        
        # sparation
        sep = wx.BoxSizer(wx.VERTICAL)
        sep.Add(wx.StaticLine(panel), 0, wx.EXPAND|wx.ALL, 5)
        
        # rsultat :
        lblresultat = wx.StaticText(panel, -1, u"Puissance estime :")
        self.resultat = wx.StaticText(panel, -1, u"... W")
        self.resultat.SetForegroundColour('blue')
        self.resultat.SetFont(wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD))
        
        # bouton "quitter"
        self.btnQuit = wx.Button(panel, -1, "Quitter")
        
        #----------------- Binds -------------------------------------
        
        self.Bind(wx.EVT_CLOSE, self.onQuitter)
        self.Bind(wx.EVT_BUTTON, self.onCalcul, self.btnCalcul)
        self.Bind(wx.EVT_BUTTON, self.onQuitter, self.btnQuit)
        self.Bind(wx.EVT_BUTTON, self.onZone, id=100)
        self.Bind(wx.EVT_BUTTON, self.onZone, id=101)
        self.Bind(wx.EVT_BUTTON, self.onZone, id=102)
        self.Bind(wx.EVT_BUTTON, self.onZone, id=103)
        self.Bind(wx.EVT_SPINCTRL, self.onRaz)
        self.Bind(wx.EVT_CHOICE, self.onRaz)
        
        #-------------- Ajout des wigets au sizer --------------------
        
        self.gbs.Add(self.carte, (0,0), span=(7,1))
        self.gbs.Add(lblChoixZone, (0,1), (1,4))
        self.gbs.Add(self.btnRouge, (1,1))
        self.gbs.Add(self.btnVert, (1,2))
        self.gbs.Add(self.btnBleu, (1,3))
        self.gbs.Add(self.btnJaune, (1,4))
        
        self.gbs.Add(lblVolume,(3,1), (1,4))
        self.gbs.Add(self.volume, (3,5))
        
        self.gbs.Add(lblHsp, (4,1), (1,4))
        self.gbs.Add(self.hsp, (4,5))
        
        self.gbs.Add(lblNbPersonnes, (5,1), (1,4))
        self.gbs.Add(self.personnes, (5,5))
        
        self.gbs.Add(lblLocal, (6,1), (1,4))
        self.gbs.Add(self.local, (6,5))
        
        self.gbs.Add(lblEnvironnement, (7,0))
        self.gbs.Add(self.environnement, (7,1), (1,5), wx.EXPAND)
        
        self.gbs.Add(lblConstruction, (8,0))
        self.gbs.Add(self.construction, (8,1), (1,5), wx.EXPAND)
        
        self.gbs.Add(lblAltitude, (9,0))
        self.gbs.Add(self.altitude, (9,1), (1,5), wx.EXPAND)
        
        
        self.gbs.Add(self.btnCalcul, (10,0))
        
        self.gbs.Add(sep, (11,0), (1,6), wx.EXPAND)
        
        self.gbs.Add(lblresultat, (12,0))
        self.gbs.Add(self.resultat, (12,1), (1,5), wx.EXPAND)
        
        self.gbs.Add(self.btnQuit, (14,0))
                
        panel.SetSizerAndFit(self.gbs)
        self.SetClientSize(panel.GetSize())
        
        #----------- variables de calcul ----------------------
        
        self.zone = 1.0
        
    def onZone(self, evt):
        if evt.GetId()== 100: # rouge
            self.zone = 0.8
            self.btnCalcul.SetBackgroundColour('red')
        if evt.GetId()== 101: # bleu
            self.zone = 1.3
            self.btnCalcul.SetBackgroundColour('blue')
        if evt.GetId()== 102: # vert
            self.zone = 1.0
            self.btnCalcul.SetBackgroundColour('green')
        if evt.GetId()== 103: # jaune
            self.zone = 1.6
            self.btnCalcul.SetBackgroundColour('yellow')
        self.btnCalcul.Enable(True)
        self.resultat.SetLabel(u"... W")
        
    def onRaz(self, evt) :
        self.resultat.SetLabel(u"... W")
            

    def onCalcul(self, evt):
        
        # Volume de la pice :
        vol = self.volume.GetValue()
        
        # Nombre de personnes occupant la pice
        nbPers = self.personnes.GetValue()
        
        # Dtermination du coef Kg en fonction de la zone gographique
        Kg = self.zone
        
        # Dtermination du coef Kc en fonction de l'environnement et du type de construction
        if self.environnement.GetSelection() == 0 :
            if self.construction.GetSelection() == 0 :
                Kc = 1.0
            elif self.construction.GetSelection() == 1 :
                Kc = 1.1
            else :
                Kc = 1.2
        elif self.environnement.GetSelection() == 1 :
            if self.construction.GetSelection() == 0 :
                Kc = 1.1
            elif self.construction.GetSelection() == 1 :
                Kc = 1.2
            else :
                Kc = 1.3
        else :
            if self.construction.GetSelection() == 0 :
                Kc = 1.2
            elif self.construction.GetSelection() == 1 :
                Kc = 1.3
            else :
                Kc = 1.4
        
        # Coef Ka de majoration pour l'altitude
        if self.altitude.GetSelection() == 0 :
            Ka = 1
        elif self.altitude.GetSelection() ==1 :
            Ka = 1.1
        elif self.altitude.GetSelection() ==2 :
            Ka = 1.2
        elif self.altitude.GetSelection() == 3 :
            Ka = 1.3
        else :
            Ka = 1.45
        
        # Coef Kh de majoration pour grande hauteur sous plafond
        if self.hsp.GetSelection() == 0 :
            Kh = 1
        elif self.hsp.GetSelection() == 1 :
            Kh = 1.03
        elif self.hsp.GetSelection() == 2 :
            Kh = 1.06
        elif self.hsp.GetSelection() == 3 :
            Kh = 1.12
        else :
            Kh = 1.18
        
        # Calcul en fonction du type de local :
        if self.local.GetSelection() == 0 :
            # si bureaux :
            K = 0.025
        else :
            # si atelier
            K = 0.050
        
        # Puissance calcule
        P = round(((K*vol*Kg*Kc)-0.2*nbPers)*Ka*Kh, 1)
        self.resultat.SetLabel("%s kW" %P)
        
        
    def onQuitter(self, evt):
        """Quitter l'application"""
        self.parent.btnChauffTertiaire.Enable(True)
        self.parent.menuModuleChauffTertiaire.Enable(True)
        self.Destroy()